#!/usr/bin/perl

# --------------------------------------------------------
#
#      To mail back issues of newsletters ( or any files )
#
#            Fisrt version 1.2
#            Dan Bloomquist dan@lakeweb.net  27 june 1996
#
#
#            revised to use without modification
#            from other servers
#            last rev. 11 oct 1996
#
#            rev 12 oct 1996 to add client to
#            mailing list.
#
#---------------------------------------------------------
#
#-----THESE PARAMETERS NEED TO BE SET FOR YOUR USE--------
#        ( you sould not need to change them )

$debug=  0;
$header= 0;  #Check if html header has been sent.
$mailprog=  '/usr/lib/sendmail';


#----------------------------------------------
#
# your subject basename sould not contain
#  any part of the following words.
#
# reserved labels ( names ):
#   'basename'  to identify valid subject labels
#   'email'     address of user.
#   'name'      real name of users.
#   'filesdir'  base directory of operation.
#   'logfile'   access logfile name.
#   'subject'   Subject of eMail.
#   'sentfrom'  Sender of the eMail ( listname ).
#
#   'listadd'   true if add to list.
#   'list'      the name of the list server.
#   'listname'  primary name of list.
#
#----------------------------------------------

#
#Read the input data
#
# get input from client ( html page ) into $buffer.
read( STDIN, $buffer, $ENV{'CONTENT_LENGTH'} );

if( $debug ){  #get the header out and anounce it.
   &header;
   print "<center><h2>Debug Mode</h2></center><br><br>\n";
   print "The input variables:<br>\n";
}

# Split the data
@pairs= split( /&/, $buffer );

foreach $pair( @pairs ){

   #Create associated list.
   ( $label, $value )= split( /=/, $pair );

   #parse out the value identities. ( Matt's )
   $value=~ tr/+/ /;
   $value=~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value=~ s/<!--(.|\n)*-->//g;
   #no html stuff
   #$value=~ s/<([^>]|\n)*>//g;

   if( $debug ){  #look at all the data from the input.
      print " LABEL: $label  VALUE: $value<br>\n";
   }
   #Associate pairs to DATA.
   $DATA{ $label }= $value;

}

$filesdir=  $DATA{ 'filesdir' };

# dajjp@hunterlink.net.au   did the address checker.

$email= $DATA{ 'email' };
if ( ( $email =~/[,|\/\\]/)             # if any illegal characters
      || ($email =~ /(@.*@)|(\.\.)/ )   # two @'s or consecutive.'s
      || (substr($email,-1,1) eq "\.")  # ends in a .
      || (index($email,'@') eq -1) )    # no @
   {
   &header;
   print "<br><br><center><h2>Your email address of $email<br>\n";
   print "Is incorectly constructed<br></h2><center><br>\n";
   print "Your email address should be in the form:<br><br>\n";
   print "<cite>username@domain.name</cite><br><br><br>\n";
   print "Please return to the previous page and enter again<br><br>\n";
   print "<center><font size=+1>[<a href=\"";
   print "$ENV{ HTTP_REFERER }\n";
   print "\">Return to Previous Page</a>]</font>\n";
   print "</center><br><br></body></html>\n";
   exit 0;
   }

#--------------------------------
#
#Send your mail out.
#

foreach $key( keys %DATA ){

   if( $debug ){  #look at all the data so far.
      print " \$key: $key \$DATA{ \$key }: $DATA{ $key }<br>\n";
   }
   if( $key=~ $DATA{ 'basename' } ){
                       #then the DATA{ $key } sould be file name.
                       #Keep in mind that reserved labels can't be used.

      if( $debug ){  #print the matches.
         &header;
         print "The mail items FILE: $filesdir$DATA{ $key }<br>\n";
         print "Subject: $DATA{ 'subject' }<br>\n";
         print "From: $DATA{ 'sentfrom' }<br>\n";
         print "Reply-to: $email - $DATA{ 'name' }<br>\n";

      }else{  #really do it.

         open( LETTER, "$filesdir$DATA{ $key }" )
            || die "can't open $filesdir$DATA{ $key }: $\n";

         @letter= <LETTER>;
         close( LETTER );

         open( MAIL, "|$mailprog $email" )
            || die "can't open sendmail: $email: $!\n";

         print MAIL "Subject: $DATA{ 'subject' }\n";
         print MAIL "From: $DATA{ 'sentfrom' }\n";
         print MAIL "Reply-to: $DATA{ 'sentfrom' }\n\n";

         foreach $letter( @letter ){
             print MAIL $letter;
         }
         close( MAIL );
      }
   }
}

#
#--------------------------------------
#
#Add user to list server.
#
if( $DATA{ 'addlist' } eq 'true' )
{
   open( MAIL, "|$mailprog $DATA{ 'list' }" )
      || die "can't open sendmail: $email: $!\n";

   print MAIL "From: $email\n\n";
   print MAIL "SUB $DATA{ 'listname' } $DATA{ 'name' }\n";
            
   close( MAIL );
}

#
#--------------------------------------
#
#Post your log
#

if( $debug ){  #What does the logfile name look like.
   print "<br>LOG:  $filesdir$DATA{ 'logfile' }<br><br>\n";

}elsif( $DATA{ 'logfile' } ne '' )
{
   open ( LOG, ">>$filesdir$DATA{ 'logfile' }" );
   print LOG "$ENV{ HTTP_USER_AGENT }, $ENV{ REMOTE_IDENT }\n";
   print LOG "$ENV{ REMOTE_HOST }, $ENV{ REMOTE_USER }\n";
   print LOG &date( time ), "\n$email - $DATA{ 'name' }\n";
   foreach $key( keys %DATA ){

      if( $debug ){  #look at all the data so far.
         print " \$key: $key \$DATA{ \$key }: $DATA{ $key }<br>\n";
      }

      if( $key=~ $DATA{ 'basename' } ){
         print LOG $DATA{ $key }, " ";
      }
   }
   print LOG "\n\n";
}

close( LOG );


#--------------------------------------
#
#Wrap it up!
#

&header;

   print "<br><br><center><h1>It's in the mail!</h1></center><br><br>\n";
   print "<center><font size=+1>[<a href=\"";
   print "$ENV{ HTTP_REFERER }\n";
   print "\">Return to Previous Page</a>]</font>\n";
   print "</center>";
   print "<br><br>html.end.";
   print "</body></html>\n";

#.end of program

#------------------------------------------
#
#
#subs
#

sub header {
   if( !$header ){
      print "Content-type: text/html\n\n";
      print "<html><head><title>Files Mailer";
      print "</title></head>\n";
      print "<body BGColor=#fffff6 Text=#000000 Link=#0000FF";
      print " VLink=#008000 ALink=#FF0000><br>\n";
      $header= 1;
   }
}

sub date
{
   local( $time, $format )= @_;
   #local( $format )= pop( @_ );

   local( $sec, $min, $hour, $mday, $mon, $year,
          $wday, $yday, $isdst )= localtime( $time );

   $sec = "0$sec" if ($sec < 10);
   $min = "0$min" if ($min < 10);
   $hour = "0$hour" if ($hour < 10);
   $mon = "0$mon" if ($mon < 10);
   $mday = "0$mday" if ($mday < 10);
   local( $month )= ($mon + 1);
   local( @months )= ( "Jan", "Feb", "Mar", "Apr", "May", "Jun",
                       "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" );

   local( @weekday )=( "Monday", "Tuesday", "Wednesday",
              "Thursday", "Friday", "Saturday", "Sunday" );

   if ( !defined( $format ) ){
      return "$mday $months[$mon] 19$year at $hour\:$min\:$sec";
   }
   #else
      return "$weekday[$wday], $mday-$month-$year $hour\:$min\:$sec GMT";
}

